Summary:	BLOPEX core library
Name:		blopex
Version:	1.1.20120619
Release:	1
License:	Non commercial use
Group:		Libraries
Source:		blopex_abstract-20120619.tar.bz2
Source1:	sample-mpi.c
URL:		http://code.google.com/p/blopex/
BuildRoot:	/var/tmp/%{name}-%{version}-root
%ifos linux
BuildArch:	i386 x86_64
%else
AutoReqProv:	no
BuildArch:	x86_64
%endif
Prefix:		/usr

%description
BLOPEX is a package, written in C, that at present includes only one
eigenxolver, Locally Optimal Block Preconditioned Conjugate Gradient Method
(LOBPCG). BLOPEX supports parallel MPI-based computations through an abstract
layer. The complex arithmetic is not yet supported in BLOPEX C codes,
but is available for MATLAB codes.

This package provides the core library of BLOPEX (blopex_abstract),
which contains the eigenxolvers codes.

%prep
%setup -q -n blopex_abstract

%build
cp -a %{SOURCE1} .
make CFLAGS="-O2 -Wall -g -fPIC"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_includedir}/blopex $RPM_BUILD_ROOT/%{_libdir}
mkdir tmp
cd tmp
ar x ../lib/libBLOPEX.a
%ifnos darwin
    gcc -shared -o $RPM_BUILD_ROOT/%{_libdir}/libBLOPEX.so *.o
%else
    clang -dynamiclib -dylinker_install_name %{_libdir}/libBLOPEX.dylib \
	-o $RPM_BUILD_ROOT/%{_libdir}/libBLOPEX.dylib *.o
%endif
cd ..
rm -rf tmp
#for h in lobpcg.h multivector.h interpreter.h; do
for h in include/*.h; do
  sed -e 's/# *include  *" */#include "blopex\//g' $h \
	> $RPM_BUILD_ROOT/%{_includedir}/blopex/`basename $h`
  chmod a+r $RPM_BUILD_ROOT/%{_includedir}/blopex/`basename $h`
done
cat <<END >$RPM_BUILD_ROOT/%{_includedir}/blopex.h
#ifndef BLOPEX_H
#define BLOPEX_H

#define BLOPEX_VERSION		%{version}
#define BLOPEX_VERSION_MAJOR	`echo %{version} | awk -F. '{print $1}'`
#define BLOPEX_VERSION_MINOR	`echo %{version} | awk -F. '{print $2}'`
#define BLOPEX_RELEASE		%{release}

#include <blopex/lobpcg.h>

#endif	/* !defined(BLOPEX_H) */
END
chmod a+r $RPM_BUILD_ROOT/%{_includedir}/blopex.h

%clean
rm -fr $RPM_BUILD_ROOT

%post
if test -x /sbin/ldconfig; then
    /sbin/ldconfig
fi

%postun
if test -x /sbin/ldconfig; then
    /sbin/ldconfig
fi

%files
%defattr(644,root,root,755)
%doc sample-mpi.c
%{_includedir}/blopex.h
%{_includedir}/blopex/*
%{_libdir}/libBLOPEX.*

%changelog
